package com.huiju.welcome.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huiju.welcome.common.base.BaseController;
import com.huiju.welcome.common.base.ResponseBean;
import com.huiju.welcome.model.SysMenu;
import com.huiju.welcome.service.ISysMenuService;
import com.huiju.welcome.utils.StatusUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.time.LocalDateTime;
import java.util.List;

@RestController
@RequestMapping("/")
public class SysMenuController extends BaseController {
    @Autowired
    ISysMenuService iSysMenuService;

    @GetMapping("/menu")
    public ResponseBean all() {
        QueryWrapper<SysMenu> queryWrapper = new QueryWrapper<>();
        queryWrapper.gt("status", StatusUtils.Delete);
        queryWrapper.orderByAsc("sort_no");

        List<SysMenu> result = iSysMenuService.list(queryWrapper);
        return ResponseBean.success(result);
    }

    @PostMapping("/menu")
    public ResponseBean save(@RequestBody SysMenu sysMenu) {
        sysMenu.setStatus(StatusUtils.Normal);
        sysMenu.setCreateDate(LocalDateTime.now());
        iSysMenuService.save(sysMenu);
        return ResponseBean.success(sysMenu);
    }

    @PutMapping("/menu/{id}")
    public ResponseBean update(@PathVariable("id") String menuId, @RequestBody SysMenu sysMenu) {
        sysMenu.setMenuId(menuId);
        iSysMenuService.updateById(sysMenu);
        return ResponseBean.success(sysMenu);
    }

    @DeleteMapping("/menu/{id}")
    public ResponseBean delete(@PathVariable("id") String menuId) {
        // 删除子节点
        QueryWrapper<SysMenu> queryWrapper = new QueryWrapper<>();
        queryWrapper.like("menu_parents", menuId);
        iSysMenuService.remove(queryWrapper);

        // 删除当前
        iSysMenuService.removeById(menuId);
        return ResponseBean.success("ok");
    }

}
