package com.huiju.welcome.service.impl;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.huiju.welcome.common.base.ResponseBean;
import com.huiju.welcome.mapper.TaMiniFormidsMapper;
import com.huiju.welcome.model.TaMiniFormids;
import com.huiju.welcome.service.ITaMiniFormidsService;
import lombok.extern.log4j.Log4j;
import lombok.extern.slf4j.Slf4j;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;

@Service
@Slf4j
public class TaMiniFormidsImpl extends ServiceImpl<TaMiniFormidsMapper, TaMiniFormids> implements ITaMiniFormidsService {
//    Logger log = LoggerFactory.getLogger(TaMiniFormidsImpl.class);

    @Autowired
    TaMiniFormidsMapper taMiniFormidsMapper;

    @Override
    public ResponseBean saveFormidBy(String openid, String paramsStr) {
        JSONObject params = JSONObject.parseObject(paramsStr);
        JSONArray formids = params.getJSONArray("formids");

        for (Object id: formids) {
            String formid = id.toString();
            if ("the formId is a mock one".equals(formid)) continue;

            TaMiniFormids taMiniFormids = new TaMiniFormids();
            taMiniFormids.setOpenid(openid);
            taMiniFormids.setFormid(formid);
            taMiniFormids.setCreateDate(LocalDateTime.now());
            taMiniFormidsMapper.insert(taMiniFormids);
        }

        return ResponseBean.success("");
    }

    @Override
    public String getFormidBy(String openid, boolean... delete) {
        TaMiniFormids taMiniFormids = taMiniFormidsMapper.getFormidCanUse(openid);
        if (null == taMiniFormids) {
            log.error("没有找对 openid [{}] 发送消息需要的 formid", openid);
            return null;
        }


        if (null != delete && delete.length > 0 && delete[0]) {
            QueryWrapper<TaMiniFormids> wrapper = new QueryWrapper<>();
            wrapper.eq("openid", openid);
            wrapper.eq("formid", taMiniFormids.getFormid());

            taMiniFormidsMapper.delete(wrapper);
        }

        return taMiniFormids.getFormid();
    }
}
